import * as clipperLib from "js-angusj-clipper/web"; // nodejs style require

export let clipperCpp: { lib?: clipperLib.ClipperLibWrapper; } = {};
export function InitClipperCpp(): Promise<void>
{
    if (clipperCpp.lib) return;
    if (!globalThis.document)
        globalThis.document = {} as any;
    return new Promise((res, rej) =>
    {
        clipperLib.loadNativeClipperLibInstanceAsync(
            // let it autodetect which one to use, but also available WasmOnly and AsmJsOnly
            clipperLib.NativeClipperLibRequestedFormat.WasmWithAsmJsFallback
        ).then(c =>
        {
            clipperCpp.lib = c;
            res();
            console.log("载入成功!");
        });
    });
}
