import { Part } from "./Part";
import { Path } from "./Path";
import { NestFiler } from "../Common/Filer";
import { PathGeneratorSingle } from "./PathGenerator";

/**
 * 排料数据库,用这个类来序列化需要排料的数据
 * 用于在Work间传输
 */
export class NestDatabase
{
    Paths: Path[]; //所有的Path都在这里
    Bin: Path;     //默认的容器
    Parts: Part[]; //所有的零件

    //#region -------------------------File-------------------------
    //对象从文件中读取数据,初始化自身
    ReadFile(file: NestFiler)
    {
        file.Read();
        let count = file.Read() as number;
        this.Paths = [];
        for (let i = 0; i < count; i++)
        {
            let path = new Path();
            path.ReadFile(file);
            this.Paths.push(path);
        }
        this.Bin = this.Paths[file.Read()];
        PathGeneratorSingle.paths = this.Paths;
        count = file.Read();
        this.Parts = [];
        for (let i = 0; i < count; i++)
        {
            let part = new Part();
            part.ReadFile(file);
            this.Parts.push(part);
        }
    }
    //对象将自身数据写入到文件.
    WriteFile(file: NestFiler)
    {
        file.Write(1);
        file.Write(this.Paths.length);
        for (let path of this.Paths)
            path.WriteFile(file);

        file.Write(this.Bin.Id);
        file.Write(this.Parts.length);
        for (let part of this.Parts)
            part.WriteFile(file);
    }
    //#endregion
}
