const ctx: Worker = self as any;
import { InitClipperCpp } from "../Common/ClipperCpp";
import { NestFiler } from "../Common/Filer";
import { NestDatabase } from "./NestDatabase";
import { OptimizeMachine } from "./OptimizeMachine";

ctx.addEventListener("message", async (event) =>
{
    await InitClipperCpp();
    let f = new NestFiler(event.data);
    let db = new NestDatabase;
    db.ReadFile(f);

    let m = new OptimizeMachine;
    m.Bin = db.Bin;
    m.PutParts(db.Parts);

    m.callBack = async (inv) =>
    {
        let f = new NestFiler();
        inv.WriteFile(f);
        ctx.postMessage(f._datas);
    };
    await m.Start();
});

export default {} as typeof Worker & (new () => Worker);
