import { Path } from "./Path";
import { Point } from "../Common/Point";
import { PathGeneratorSingle } from "./PathGenerator";
import { NestFiler } from "../Common/Filer";

/**
 * 用于存放零件旋转后的状态
 * 记录了用于放置时的轮廓。该轮廓总是首点等于0，便于放置时的计算。
 */
export class PartState
{
    Rotation: number;
    OrigionMinPoint: Point;
    Contour: Path;//轮廓

    //#region -------------------------File-------------------------
    ReadFile(file: NestFiler)
    {
        this.Rotation = file.Read();
        this.OrigionMinPoint = file.Read();

        let index = file.Read() as number;
        this.Contour = PathGeneratorSingle.paths[index];

        if (!this.Contour)
            console.log(index);
    }
    WriteFile(file: NestFiler)
    {
        file.Write(this.Rotation);
        file.Write(this.OrigionMinPoint);
        file.Write(this.Contour.Id);
    }
    //#endregion
}
