// vue.config.js
const path = require("path");
function resolve(dir) {
  return path.join(__dirname, dir);
}
module.exports = {
  // publicPath: '',
  runtimeCompiler: true,
  productionSourceMap: false,
  configureWebpack: {
    devtool: "source-map",
    output: {
      globalObject: "this",
    },
  },
  chainWebpack(config) {
    let  tsRule = config.module
    .rule("ts").uses;
    config.module
      .rule("worker")
      .test(/\.worker\.ts$/i)
      .use("worker-loader")
      .loader("worker-loader").end()
      .use("ts-loader")
      .loader("ts-loader").options({
        transpileOnly: true,
        happyPackMode: false
      }).end();
    config.module
      .rule("fonts")
      .use("url-loader")
      .loader("url-loader")
      .options({
        limit: 4096,
        fallback: {
          loader: "file-loader",
          options: {
            name: "fonts/[name].[contenthash].[ext]",
          },
        },
      })
      .end();
  },
};
